package com.oreilly.jent.ejb.stateful;

/**
 * In general, you may use the code in this book in your programs and 
 * documentation. You do not need to contact us for permission unless 
 * you're reproducing a significant portion of the code. For example, 
 * writing a program that uses several chunks of code from this book does 
 * not require permission. Selling or distributing a CD-ROM of examples 
 * from O'Reilly books does require permission. Answering a question by 
 * citing this book and quoting example code does not require permission. 
 * Incorporating a significant amount of example code from this book into 
 * your product's documentation does require permission.
 * 
 * We appreciate, but do not require, attribution. An attribution usually 
 * includes the title, author, publisher, and ISBN. For example: 
 * 
 *   "Java Enterprise in a Nutshell, Third Edition, 
 *    by Jim Farley and William Crawford 
 *    with Prakash Malani, John G. Norman, and Justin Gehtland. 
 *    Copyright 2006 O'Reilly Media, Inc., 0-596-10142-2."
 *  
 *  If you feel your use of code examples falls outside fair use or the 
 *  permission given above, feel free to contact us at 
 *  permissions@oreilly.com.
 */

import java.util.Properties;

import javax.ejb.SessionBean;
import javax.ejb.SessionContext;

import com.oreilly.jent.ejb.NoSuchPersonException;

// A stateful session Profile, which provides profile information
// for a named person.
public class ProfileBean implements SessionBean {

  // State for this (stateful) bean

  // Name of the person owning the profile
  private String mName = "";
  // Entries in the profile (name/value pairs)
  private Properties mEntries = new Properties();
  
  // Store session context
  private SessionContext mContext = null;
  
  //--------------------------------------------------
  // Session bean methods
  //--------------------------------------------------

  // No need for us to activate anything in this bean, but we need to
  // provide an implementation.
  public void ejbActivate() {
    System.out.println("ProfileBean activated.");
  }

  // Nothing to do on a remove.
  public void ejbRemove() {
    System.out.println("ProfileBean removed.");
  }

  // No resources to release on passivation...
  public void ejbPassivate() {
    System.out.println("ProfileBean passivated.");
  }

  // Get context from container.
  public void setSessionContext(SessionContext context) {
    System.out.println("ProfileBean context set.");
    mContext = context;
  }
  
  // Create method with name of profile owner.
  public void ejbCreate(String name) throws NoSuchPersonException {
    mName = name;
    System.out.println("ProfileBean created for " + mName + ".");
  }

  //--------------------------------------------------
  // Business methods
  //--------------------------------------------------

  public String getName() {
    return mName;
  }
  
  public String getEntry(String key) {
      return mEntries.getProperty(key);
  }

  public void setEntry(String key, String value) {
      mEntries.put(key, value);
  }
}
